# Chapter Two: Creating a Bitcoin-Core VPS

To get started with Bitcoin, you first need to set up a machine running Bitcoin. The articles in this chapter describe how to do so, primarily by using a VPS (Virtual Private Server).

## Objectives for this Chapter

After working through this chapter, a developer will be able to:

   * Decide Between the Five Major Types of Bitcoin Nodes
   * Create a Bitcoin Node for Development
   * Create a Local Instance of the Bitcoin Blockchain

Supporting objectives include the ability to:

   * Understand the Basic Network Setup of the VPS
   * Decide Which Security Priorities to Implement
   * Understand the Difference between Pruned and Unpruned Nodes
   * Understand the Difference between Mainnet, Testnet, and Regtest Nodes
   * Interpret the Basics of the Bitcoin Configuration File
   
## Table of Contents

You don't actually need to read this entire chapter. Decide if you want to set up your VPS by hand, typing in every command (§2.1); if you want to run a StackScript to set it up on a Linode VPS (§2.2); or you want to set up on a different environment, such as on an AWS machine or a Mac (§2.3). Then, jump to the appropriate section.

   * [Section One: Setting Up a Bitcoin Core VPS by Hand](02_1_Setting_Up_a_Bitcoin-Core_VPS_by_Hand.md)
   * [Section Two: Setting Up a Bitcoin Core VPS with Bitcoin Standup](02_2_Setting_Up_a_Bitcoin-Core_VPS_with_StackScript.md)
   * [Section Three: Setting Up a Bitcoin Core Machine via Other Means](02_3_Setting_Up_Bitcoin_Core_Other.md)
